<?php
namespace Incoviba\Repository\Proyecto;

use Incoviba\Common\Define;
use Incoviba\Common\Ideal;
use Incoviba\Common\Implement;
use Incoviba\Model;
use Incoviba\Repository;

class ProyectoTipoUnidad extends Ideal\Repository
{
    public function __construct(Define\Connection $connection, protected Repository\Proyecto $proyectoRepository, protected Repository\Venta\TipoUnidad $tipoUnidadRepository)
    {
        parent::__construct($connection);
        $this->setTable('proyecto_tipo_unidad');
    }

    public function create(?array $data = null): Define\Model
    {
        $map = (new Implement\Repository\MapperParser(['nombre', 'abreviacion', 'logia', 'terraza', 'descripcion']))
            ->register('proyecto', (new Implement\Repository\Mapper())
                ->setFunction(function($data) {
                    return $this->proyectoRepository->fetchById($data['proyecto']);
                }))
            ->register('tipo', (new Implement\Repository\Mapper())
                ->setProperty('tipoUnidad')
                ->setFunction(function($data) {
                    return $this->tipoUnidadRepository->fetchById($data['tipo']);
                }))
            ->register('m2', (new Implement\Repository\Mapper())
                ->setProperty('util'));
        return $this->parseData(new Model\Proyecto\ProyectoTipoUnidad(), $data, $map);
    }
    public function save(Define\Model $model): Define\Model
    {
        $model->id = $this->saveNew(
            ['proyecto', 'tipo', 'nombre', 'abreviacion', 'm2', 'logia', 'terraza', 'descripcion'],
            [$model->proyecto->id, $model->tipoUnidad->id, $model->nombre, $model->abreviacion, $model->util, $model->logia, $model->terraza, $model->descripcion]
        );
        return $model;
    }
    public function edit(Define\Model $model, array $new_data): Define\Model
    {
        return $this->update($model, ['proyecto', 'tipo', 'nombre', 'abreviacion', 'util', 'logia', 'terraza', 'descripcion'], $new_data);
    }
}
